<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Graham Featherstone - Project 15</title>
    <link href="../../styles.css" rel="stylesheet" />
</head>

<body>
    <header>
        <div class="container">
            <div class="text-container">
                <h1>Graham Featherstone</h1>
                <p>Chemical Engineering Student | Teacher | Enthusiast</p>
            </div>
            <img src="../../Cropped2.jpg" width="200px">
        </div>
    </header>

    <section>
        <h1>Project 15</h1>
        <h2>
            Key Objectives
        </h2>
        <hl>
            <li>Write an application that interfaces a user with an input and/or output device that you made.</li>
            <li>Include a hero video and source files of the application in your documentation.</li>
        </hl>
    </section>

    <section>
        <h1>
            Interfacing with my final project
        </h1>
        <p>
            For my final project, I needed to develop an interface that is simple to use, accessible, and that performs
            the function that is required in our research laboratory.
            For this purpose, I used a python addition called Tkinter to create a desktop app that can by ran through
            python. With this application,
            I was able to quickly interface with my FG pins on my motors, as well as send commands to motors to alter
            their speeds and directions. However, the direction of the motor was set
            in the python IDE application, since my final project only functions in one direction. There is no use for
            the motors to change directions.
        </p>
        <p>However, speed control is a critical component of my final project. For this purpose, I wrote a loop in the
            python IDE which takes 50 samples from each motor, averages the RPM, and prints this RPM using serial output
            for the 4 motors that required
            speed control. As the speed of the motors is set by the a PWM output to the PWN pin on the motors, it is not
            possible to directly set the RPM. For this circumstance, I use the RPM value output from the FG pin on the
            motors to dictate the length of the PWM signal. If the motor
            is traveling slower than the input RPM, the PWM pin adjusts automatically; either speeding up, slowing down,
            or maintaining the same PWM value output to the motors.
        </p>
        <p> This self modulating function is very important to the success of the final project as the motor speed will
            need to adjust in two different ways. The first is that the speed of the motors will need to adjust
            based on the serial input from the user. As the user will be modifying both the jet-draw ratio, and the
            post-draw ratio simultaneously, the motors will need to react to these changes in a controlled manner
            to not put any extra stress on the regenerated fibres. Secondly, the load on the motors is going to change
            throughout the experiments and depending on the set RPM values; under high-load the motor will slow down.
            With the code that I
            integrated into the device, this RPM reduction will be detected and adjusted accordingly according to the
            load that the motor is experiencing.
        </p>
        <p> In addition to the above, I also imported a math function into my python program which will output the RPM
            values received from the FG pin graphically so that the user can monitor and export the RPM values that were
            used throughout the duration of the trial. </p>
    </section>

    <section>
        <h1>Interacting with the Raspberry Pi Pico W using Tkinter</h1>
        <p>
            To create the basis for the Tkinter code, I used chatGPT to formulate a template and the message boxes that
            I wanted for the interface. I also utilized chatGPT to write the function which will receive the serial
            input from Tkinter and allow the Pico W to convert it to
            two separate values (RPM, stretch-ratio). I needed to prompt several changes with ChatGPT, and manually
            alter some values to make them work with the baud-rate and serial COM port that I was using.
        </p>
        <p>The code for creating the Tkinter interface is provided below.</p>
        <pre>
import tkinter as tk
from tkinter import messagebox
import serial
import threading
import time
import re
import matplotlib.pyplot as plt
from matplotlib.animation import FuncAnimation

# Set up serial connection (adjust 'COM8' to your port and baudrate to your setting)
ser = serial.Serial('COM8', 115200, timeout=1)

# Data lists for plotting
time1_data = []
time2_data = []
time3_data = []
time4_data = []
rpm1_data = []
rpm2_data = []
rpm3_data = []
rpm4_data = []
stretch_ratio_data = []
start_time = time.time()

# Function to send data to Raspberry Pi Pico
def send_data():
    try:
        rpm = int(rpm_entry.get().strip())
        stretch_ratio = float(stretch_ratio_entry.get().strip())
        data = f"{rpm},{stretch_ratio}\n"
        ser.write(data.encode())
        rpm_entry.delete(0, tk.END)
        stretch_ratio_entry.delete(0, tk.END)
    except ValueError:
        messagebox.showerror("Invalid Input", "Please enter a valid RPM (int) and stretch ratio (float).")
    except serial.SerialException as e:
        messagebox.showerror("Serial Error", str(e))

# Function to read data from Raspberry Pi Pico
def read_data():
    while True:
        if ser.in_waiting:
            data = ser.readline().decode('utf-8').strip()
            text_display.insert(tk.END, data + '\n')  # Insert the received data into the Text widget
            text_display.see(tk.END)  # Scroll to the end to show the latest data
            try:
                # Use regular expression to extract integer from the data
                if "RPM1" in data:

                    match = re.search(r'\d+', data)
                    if match:
                        rpm = int(match.group())
                        current_time = time.time() - start_time
                        time1_data.append(current_time)
                        rpm1_data.append(rpm)
                elif "RPM2" in data:
                    match = re.search(r'\d+', data)
                    if match:
                        rpm = int(match.group())
                        current_time = time.time() - start_time
                        time2_data.append(current_time)
                        rpm2_data.append(rpm)
                elif "RPM3" in data:
                    match = re.search(r'\d+', data)
                    if match:
                        rpm = int(match.group())
                        current_time = time.time() - start_time
                        time3_data.append(current_time)
                        rpm3_data.append(rpm)
                elif "RPM4" in data:
                    match = re.search(r'\d+', data)
                    if match:
                        rpm = int(match.group())
                        current_time = time.time() - start_time
                        time4_data.append(current_time)
                        rpm4_data.append(rpm)
            except ValueError:
                pass
        time.sleep(0.1)

# Function to update the plot
def update_plot(frame):
    ax1.clear()
    ax1.plot(time1_data, rpm1_data, label="RPM1", color='blue')
    ax1.plot(time2_data, rpm2_data, label="RPM2", color='red')
    ax1.plot(time3_data, rpm3_data, label="RPM3", color='green')
    ax1.plot(time4_data, rpm4_data, label="RPM4", color='orange')
    ax1.set_xlabel("Time (s)")
    ax1.set_ylabel("RPM", color='blue')
    ax1.tick_params(axis='y', labelcolor='blue')
    ax1.legend(loc='upper left')

    # Auto-scale the plot based on the data
    if len(time1_data) > 0:
        ax1.set_xlim(min(time3_data), max(time3_data))
    if len(rpm1_data) > 0:
        ax1.set_ylim(min(rpm1_data), max(rpm3_data))

# Start thread for reading data
read_thread = threading.Thread(target=read_data, daemon=True)
read_thread.start()

def on_enter(event):
    send_data()

# Set up the Tkinter window
root = tk.Tk()
root.title("Raspberry Pi Pico Serial Interface")

tk.Label(root, text="Enter RPM (int):").pack(pady=5)
rpm_entry = tk.Entry(root, width=50)
rpm_entry.pack(pady=5)

tk.Label(root, text="Enter Stretch Ratio (float):").pack(pady=5)
stretch_ratio_entry = tk.Entry(root, width=50)
stretch_ratio_entry.pack(pady=5)

submit_button = tk.Button(root, text="Submit", command=send_data)
submit_button.pack(pady=10)

text_display = tk.Text(root, height=10, width=50)
text_display.pack(pady=10)

# Set up the matplotlib figure and axes
fig, ax1 = plt.subplots()
ax2 = ax1.twinx()

# Animation function
ani = FuncAnimation(fig, update_plot, interval=500, cache_frame_data=False)

# Display the plot in a new window
def show_plot():
    plt.show()

plot_button = tk.Button(root, text="Show Plot", command=show_plot)
plot_button.pack(pady=10)
root.bind('<Return>', on_enter)
# Start the Tkinter event loop
root.mainloop()
ser.close()

        </pre>
<p>
    The code for the Raspberry Pi Pico to interpret the signal is provided below:
</p>
<pre>
int k = 0;
unsigned long runningTime = 0;
bool flag = HIGH;
int speed1 = 200;
int speed2 = 200;
int speed3 = 200;
int speed4 = 200;
int speed5 = 200;
int speed6 = 200;
int rpm = 50;
int stretch = 50;
int numSamples = 100;
int calcRPM1 = 0;
int calcRPM2 = 0;
int calcRPM3 = 0;
int calcRPM4 = 0;
int calcRPM5 = 0;
int calcRPM6 = 0;
float stretch_ratio = 1;
int actualRPM1;
int actualRPM2;
int actualRPM3;
int actualRPM4;


void setup() {
  Serial.begin(115200);
  while (!Serial) {
    ;  // Wait for serial port to connect. Needed for native USB
  }
  pinMode(0, OUTPUT);   //PWM PIN 11  with PWM wire Motor 3
  pinMode(1, OUTPUT);   //direction control PIN 10 with direction wire Motor 3
  pinMode(2, INPUT);    //FG Motor 3
  pinMode(3, OUTPUT);   //PWM PIN 11  with PWM wire Motor 4
  pinMode(4, OUTPUT);   //direction control PIN 10 with direction wire Motor 4
  pinMode(5, INPUT);    //FG Motor 4
  pinMode(6, OUTPUT);   //PWM PIN 11  with PWM wire Motor 6
  pinMode(7, OUTPUT);   //direction control PIN 10 with direction wire Motor 6
  pinMode(8, INPUT);    //FG Motor 6
  pinMode(9, OUTPUT);   //PWM PIN 11  with PWM wire Motor 2
  pinMode(10, OUTPUT);  //direction control PIN 10 with direction wire Motor 2
  pinMode(11, INPUT);   //FG Motor 2
  pinMode(12, OUTPUT);  //PWM PIN 11  with PWM wire MOTOR 1
  pinMode(13, OUTPUT);  //direction control PIN 10 with direction wire MOTOR 1
  pinMode(14, INPUT);   //FG MOTOR 1
  pinMode(15, OUTPUT);  //PWM PIN 11  with PWM wire Motor 5
  pinMode(16, OUTPUT);  //direction control PIN 10 with direction wire Motor 5
  pinMode(17, INPUT);   //FG Motor 5
  rpm = 50;
  stretch = 50;
  analogWrite(0, speed3);   //Motor 3
  analogWrite(3, speed4);   //Motor 4
  analogWrite(6, speed6);   //Motor 6
  analogWrite(9, speed2);   //Motor 2
  analogWrite(12, speed1);  //Motor 1
  analogWrite(15, speed5);  //Motor 5
  digitalWrite(1, HIGH);
  digitalWrite(4, HIGH);
  digitalWrite(13, HIGH);
  digitalWrite(10, HIGH);
  digitalWrite(7, LOW);
  digitalWrite(16, LOW);
}

void loop() {

  analogWrite(0, speed3);   //Motor 3
  analogWrite(3, speed4);   //Motor 4
  analogWrite(6, speed6);   //Motor 6
  analogWrite(9, speed2);   //Motor 2
  analogWrite(12, speed1);  //Motor 1
  analogWrite(15, speed5);  //Motor 5
  digitalWrite(1, HIGH);
  digitalWrite(4, HIGH);
  digitalWrite(13, HIGH);
  digitalWrite(10, HIGH);
  digitalWrite(7, LOW);
  digitalWrite(16, LOW);

  unsigned long pulseDurations1[numSamples];
  unsigned long totalDuration1 = 0;
  unsigned long averageDuration1 = 0;

  unsigned long pulseDurations2[numSamples];
  unsigned long totalDuration2 = 0;
  unsigned long averageDuration2 = 0;

  unsigned long pulseDurations3[numSamples];
  unsigned long totalDuration3 = 0;
  unsigned long averageDuration3 = 0;

  unsigned long pulseDurations4[numSamples];
  unsigned long totalDuration4 = 0;
  unsigned long averageDuration4 = 0;


  unsigned long pulseDurations6[numSamples];
  unsigned long totalDuration6 = 0;
  unsigned long averageDuration6 = 0;

  if (Serial.available() > 0) {
    String input = Serial.readStringUntil('\n');
    int commaIndex = input.indexOf(',');
    if (commaIndex != -1) {
      String intValueStr = input.substring(0, commaIndex);     // Extract integer part
      String floatValueStr = input.substring(commaIndex + 1);  // Extract float part

      rpm = intValueStr.toInt();                // Convert integer part to int
      stretch_ratio = floatValueStr.toFloat();  // Convert float part to float
      //rpm = Serial.parseInt();
    }
  }
  stretch = rpm * stretch_ratio;

  for (int k = 0; k < numSamples; k++) {  //MOTOR 1 CODE
    pulseDurations1[k] = pulseIn(14, HIGH);
    totalDuration1 += pulseDurations1[k];
    pulseDurations2[k] = pulseIn(11, HIGH);
    totalDuration2 += pulseDurations2[k];
    pulseDurations3[k] = pulseIn(2, HIGH);
    totalDuration3 += pulseDurations3[k];
    pulseDurations4[k] = pulseIn(5, HIGH);
    totalDuration4 += pulseDurations4[k];
    //delay(5);  // Short delay between readings
  }
  
  averageDuration1 = totalDuration1 / numSamples;
  calcRPM1 = 111111 / averageDuration1;
  actualRPM1 = 111111 / pulseIn(14, HIGH);
  Serial.print(calcRPM1);  //speed   r/min  (60*1000000/(45*6*2*i))
  Serial.println(" RPM1");
  if (rpm > actualRPM1) {
    speed1 -= 1;
  }
  else if (rpm < actualRPM1){
    speed1 += 1;
  }
  else {
    speed1 = speed1;
  }
  
  
  averageDuration2 = totalDuration2 / numSamples;
  calcRPM2 = 111111 / averageDuration2;
  actualRPM2 = 111111 / pulseIn(11, HIGH);
  Serial.print(calcRPM2);  //speed   r/min  (60*1000000/(45*6*2*i))
  Serial.println(" RPM2");
  if (rpm > actualRPM2) {
    speed2 -= 1;
  }
  else if (rpm < actualRPM2){
    speed2 += 1;
  }
  else {
    speed2 = speed2;
  }
  
  
  averageDuration3 = totalDuration3 / numSamples;
  calcRPM3 = 111111 / averageDuration3;
  actualRPM3 = 111111 / pulseIn(2, HIGH);
  Serial.print(calcRPM3);  //speed   r/min  (60*1000000/(45*6*2*i))
  Serial.println(" RPM3");
  if (stretch > actualRPM3) {
    speed3 -= 1;
  }
  else if (stretch < actualRPM3){
    speed3 += 1;
  }
  else {
    speed3 = speed3;
  }
  
  averageDuration4 = totalDuration4 / numSamples;
  calcRPM4 = 111111 / averageDuration4;
  actualRPM4 = 111111 / pulseIn(5, HIGH);
  Serial.print(calcRPM4);  //speed   r/min  (60*1000000/(45*6*2*i))
  Serial.println(" RPM4");
  if (stretch > actualRPM4) {
    speed4 -= 1;
  } 
  else if (stretch < actualRPM4){
    speed4 += 1;
  }
  else {
    speed4 = speed4;
  }
}
</pre>
<h1>Output/Input Images</h1>
<p>
    Using the above code, here are the results.
    <video width="720" height="480" autoplay muted>
      <source src="Project15Images/graph1.mp4" type="video/mp4">
    </video>
</p>

<p> There are still some improvements that I need to make for the iterations and motor speed control to hopefully reduce the RPM 
  deviations slightly. 
</p>
    </section>


</body>

</html>